package org.mercury_im.messenger.util;

import java.util.Iterator;
import java.util.Map;

import io.reactivex.functions.Function;

public class DebugUtils {

    public static <K, V> String mapToString(Map<K, V> map) throws Exception {
        return mapToString(map, K::toString, V::toString);
    }

    public static <K, V> String mapToString(Map<K, V> map, Function<K, String> keyToString, Function<V, String> valueToString) throws Exception {
        StringBuilder sb = new StringBuilder("[");
        for (Iterator<Map.Entry<K, V>> iterator = map.entrySet().iterator(); iterator.hasNext(); ) {
            Map.Entry<K, V> entry = iterator.next();
            sb.append(keyToString.apply(entry.getKey())).append(": ").append(valueToString.apply(entry.getValue()));
            if (iterator.hasNext()) {
                sb.append(",\n");
            }
        }
        return sb.append(']').toString();
    }
}
